/*
 * TrekCGI WebMixmaster 0.91  --  Web interface to mixmaster anon-remailer
 * Copyright (C) 2000 Trek <trek@mediaservice.net> <trek00@freenet.hut.fi>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 * or see http://www.opensource.org/licenses/gpl-license.html
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "trekcgilib.h"

#define NOSSLWARN "<H2><FONT COLOR=\"#EE0000\">Warning: this connection IS NOT encrypted.</FONT> Use <A HREF=\"https://%s\">secure http</A>.</H2>"

#define AC_EADDRESS "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890.@_-=!"
#define BUFFERSIZ 40960
char *__Generated__s = "<I>Generated by <A HREF=\"http://www.trek.eu.org/devel/webmixmaster.html\">WebMixmaster</A> - Copyright (C) 2000 Trek.</I>";


int main(int argc, char **argv, char **envp)
{
	char *query, destto[128], subject[256], https[6],
	     *buff;
	char **queryp, *vals[5];
	FILE *mixpipe;


        /* alloc memory buffers */
        if (((query=(char *)malloc(BUFFERSIZ*sizeof(char))) == NULL) ||
           ((buff=(char *)malloc(BUFFERSIZ*sizeof(char))) == NULL))
                return(-1);

	/* read input with POST method */
	fgets(query, BUFFERSIZ, stdin);
	if ((queryp=parsequery(query, queryp)) == NULL)
		return(-1);

	/* show the main page (with form) */
	if (*queryp[0] == 0) {
		/* if not encrypted send warn */
		extract_env(envp, "HTTPS", https, 6);
		if(strncmp(https, "on", 3)) {
			extract_env(envp, "HTTP_HOST", buff, 4096);
			strncpy(query, buff, 4096);
			extract_env(envp, "REQUEST_URI", buff, 4096);
			strncat(query, buff, 4096);
			snprintf(buff, BUFFERSIZ, NOSSLWARN, query);
			vals[0]=buff;
		} else
			vals[0]="";
		vals[1]=__Generated__s; vals[2]=NULL;
		show_tmpl(TMPL_INIT, vals);
		return(0);
	}

	/* extract destination address from the query and test invalid chars */
	extract_env(queryp, "to", destto, 128);
	if (allowchars(destto, AC_EADDRESS) || (strchr(destto, '@')==NULL)
            || (strchr(destto, '.')==NULL)) {
		vals[0]="Invalid destination address.";
		vals[1]=__Generated__s; vals[2]=NULL;
		show_tmpl(TMPL_ERR, vals);
		return(-1);
	}
 	
	/* this is the security-related part of the program: I don't know
	   about the real security of this call.
	   non of the input are in the popen commandile, but it is sent 
	   to the stdin of mixmaster not treathed for evil chars. */
	snprintf(query, BUFFERSIZ, "%s >/dev/null 2>&1", MIXPROG);
	if ((mixpipe=popen(query, "w"))==NULL) {
		vals[0]="Internal Server Error.";
		vals[1]=__Generated__s; vals[2]=NULL;
		show_tmpl(TMPL_ERR, vals);
		return(-1);
	}

	extract_env(queryp, "subject", subject, 256);
	fprintf(mixpipe, "To: %s\nSubject: %s\n", destto, subject);
	extract_env(queryp, "header", buff, BUFFERSIZ);
	fprintf(mixpipe, "%s\n\n", buff);
	extract_env(queryp, "message", buff, BUFFERSIZ);
	fprintf(mixpipe, "%s", buff);
	pclose(mixpipe);

	vals[0]=destto; vals[1]=subject; vals[2]=buff;
	vals[3]=__Generated__s; vals[4]=NULL;
	show_tmpl(TMPL_SENT, vals);

	free(query);
	free(buff);
	return(0);
}

