/*
 * GNUTrekCGIlib 0.2   --   http://www.trek.eu.org/trekcgi/?lib
 * Copyright (C) 1999,2000 Trek <trek@mediaservice.net> <trek00@freenet.hut.fi>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 * or see http://www.opensource.org/licenses/gpl-license.html
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "trekcgilib.h"

#define CONTENTXT "Content-type: "

char *__Copyright__c = "<!-- TrekCGIlib Copyright (c) 1999,2000 Trek <trek@mediaservice.net> <trek00@freenet.hut.fi> http://www.trek.eu.org/trekcgi/?lib -->\n";


#define readtmpl	(c=fgetc(ftemplate))
#define keytempl(x,y)	*(tmplkey+(KEYSIZE*x)+y)
#define endkeywords(x)	(values[x] != NULL)

int show_tmpl(char *template, char **values)
{
	int i, keys=0;
	FILE *ftemplate;
	char c, *tmplkey, parsedkey[KEYSIZE+1];


	for(i=0; endkeywords(i); i++);
	if (((tmplkey = calloc(KEYSIZE+1, i+1)) == NULL) ||
	    ((ftemplate=fopen(template, "r")) == NULL)) {
		printf("%s text/html\n\nInternal Server Error.\n", CONTENTXT);
		return(-1);
	}

	/* scan the template header */
	readtmpl;
	while(c != EOF &&
	     (c == '\n' || c == '\r' || c == '\t' || c == ' ' || c == '$' || c == ')')) {
		if(c == '$') {
			if(readtmpl == '(') {
				for(i=0; readtmpl != ')'; (i<KEYSIZE?i++:i))
					keytempl(keys,i) = c;
				keytempl(keys,i) = '\0';
				/* skip keywords after allocated size */
				if(endkeywords(keys))
					keys++;
			}
		} else
			readtmpl;
	}

	/* at the end of the header get the HTTP object type */
	printf("%s%c", CONTENTXT, c);
	for(i=0; readtmpl != '\n'; i++)
		putchar(c);
	printf("\n\n%s", __Copyright__c);

	/* parse the template body */
	while(readtmpl != EOF) {
		if(c == '$') {
			if(readtmpl == '(') {
				for(i=0; readtmpl != ')'; (i<KEYSIZE?i++:i))
					parsedkey[i] = c;
				parsedkey[i] = 0;
				for(i=0; endkeywords(i); i++)
					if(!strcmp(parsedkey, (tmplkey+(KEYSIZE*i)) )) {
						printf(values[i]);
						break;
					}
			}
		} else
			putchar(c);
	}
	fclose(ftemplate);
	free(tmplkey);
	return(0);
}

